var SYNC_START_TIME = 1;
var SYNC_LESSON_LOCATION = 2;
var SYNC_SUSPEND_DATA = 4;
var SYNC_END_TIME = 8;
var SYNC_STATUS = 16;
var SYNC_SCORE = 32;
var SYNC_DURATION = 64;
var SYNC_COMPLETED_DATE = 128;
var SYNC_ASS_HIST = 256;
var SYNC_ASS_EXIT = 512;

var Chk_Status;


function openCustomURLinIFrame(src) {
    var rootElm = document.documentElement;
    var newFrameElm = document.createElement("IFRAME");
    newFrameElm.setAttribute("src", src);
    rootElm.appendChild(newFrameElm);
    //remove the frame now
    newFrameElm.parentNode.removeChild(newFrameElm);
}

function SendDataToApp(cmd, data) {
    if (Number(sessionStorage["OSType"]) == 51) {
        var url = "glelearning:///Cmd=" + cmd + ", data=" + data;
        openCustomURLinIFrame(url);
    }
    else {
        var url = "glelearning://Cmd=" + cmd + ", data=" + data;
        openCustomURLinIFrame(url);
    }
}

function ReceiveDataFromApp(cmd, data) {


    if (cmd == 'getSummary') {
        var Arr = data;
        sessionStorage["AssgDate"] = Arr[0].AssignedDate;
        sessionStorage["TotalTime"] = 0;

    }
    else if (cmd == 'getHistory') {
       
        var Arr = JSON.parse(data);

       
        for (i = 0; i < Arr.length; i++) {
            var curData = Arr[i];
           
            switch (curData.Element) {
                case "StartTime":
                    sessionStorage["StartTime"] = curData.Value;
                    break;

                case "LessonLocation":
                    sessionStorage["LessonLocation"] = curData.Value;
                    break;

                case "SuspendData":
                    sessionStorage["SuspendData"] = curData.Value;
                    break;

                case "EndTime":
                    sessionStorage["EndTime"] = curData.Value;
                    break;

                case "Status":
                    sessionStorage["Status"] = curData.Value;
                    break;

                case "Score":
                    sessionStorage["Score"] = curData.Value;
                    break;

                case "TotalTime":
                    sessionStorage["TotalTime"] = curData.Value;
                    break;
					
				default:
					if(curData.Element.includes("AssQues-"))
						{
							var str = curData.Element;
							var res = str.slice(8, 10);
							var Q = parseInt(res-1);
							var QuestHist = JSON.parse(sessionStorage["QuestionHistory"]);
							var curquet = JSON.parse(curData.Value); 
							if (curquet.CorrectAnswer == curquet.UserSelectedAnswer)
							{
								QuestHist[Q] = { QuestIndex: Q, Quest: curquet.Question, Opt1: curquet.CorrectAnswer, Opt2: "",Opt3:"",Opt4:"", CorrAns: 1, UserSelectedAns: 1};
							}
							else
							{
								QuestHist[Q] = { QuestIndex: Q, Quest: curquet.Question, Opt1: curquet.CorrectAnswer, Opt2: curquet.UserSelectedAnswer,Opt3:"",Opt4:"", CorrAns: 1, UserSelectedAns: 2};
							}
							sessionStorage["QuestionHistory"] = JSON.stringify(QuestHist);
							
						}

            }

        }
    }
    else if (cmd == 'saveHistory') {
        
    }
    else if (cmd == 'saveSummary') {
        
    }


}


function Offline_GetELearningSummaryByTrainingPlan() {
    var QueryData = [{ "SiteId": Number(sessionStorage["SiteID"]), "TPId": Number(sessionStorage["TPId"])}];

    SendDataToApp("getSummary", JSON.stringify(QueryData));
}

function Offline_GetELearningHistoryByTrainingPlan() {
    var QueryData = [{ "SiteId": Number(sessionStorage["SiteID"]), "TPId": Number(sessionStorage["TPId"])}];

    SendDataToApp("getHistory", JSON.stringify(QueryData));
}

function GetELearningSummaryByTrainingPlan() {
  
    $.ajax({
        type: 'GET',
        url: sessionStorage["serverPath"] + "/" + sessionStorage["getElerningSummary"] + "/" + sessionStorage["SiteID"] + "," + sessionStorage["TPId"],
        success: function (data) {
            sessionStorage["AssgDate"] = data[0].AssgDate;

        },
        dataType: 'json',
        crossDomain: true,
        async: false,
        error: function (jqXHR, exception) {
            var msg = '';
            if (jqXHR.status === 0) {
                msg = 'Not connect.\n Verify Network.';
            } else if (jqXHR.status == 404) {
                msg = 'Requested page not found. [404]';
            } else if (jqXHR.status == 500) {
                msg = 'Internal Server Error [500].';
            } else if (exception === 'parsererror') {
                msg = 'Requested JSON parse failed.';
            } else if (exception === 'timeout') {
                msg = 'Time out error.';
            } else if (exception === 'abort') {
                msg = 'Ajax request aborted.';
            } else {
                msg = 'Uncaught Error.\n' + jqXHR.responseText;
            }

        },
        beforeSend: function () {
            
        },
        complete: function () {
           
        }
    });

}


function GetELearningHistoryByTrainingPlan() {
    
    $.ajax({
        type: 'GET',
        url: sessionStorage["serverPath"] + "/" + sessionStorage["getElerningHistory"] + "/" + sessionStorage["SiteID"] + "," + sessionStorage["TPId"],
        success: function (data) {

            var Arr = data;


            for (i = 0; i < Arr.length; i++) {
                var curData = Arr[i];
                
                switch (curData.Element) {
                    case "StartTime":
                        sessionStorage["StartTime"] = curData.Value;
                        break;

                    case "LessonLocation":
                        sessionStorage["LessonLocation"] = curData.Value;
                        break;

                    case "SuspendData":
                        sessionStorage["SuspendData"] = curData.Value;
                        break;

                    case "EndTime":
                        sessionStorage["EndTime"] = curData.Value;
                        break;

                    case "Status":
                        sessionStorage["Status"] = curData.Value;
                        break;

                    case "Score":
                        sessionStorage["Score"] = curData.Value;
                        break;

                    case "TotalTime":
                        sessionStorage["TotalTime"] = curData.Value;
						break;
					
					default:
						if(curData.Element.includes("AssQues-"))
						{	
							var str = curData.Element;
							var res = str.slice(8, 10);
							var Q = parseInt(res-1);
							var QuestHist = JSON.parse(sessionStorage["QuestionHistory"]);
							var curquet = JSON.parse(curData.Value); 
							if (curquet.CorrectAnswer == curquet.UserSelectedAnswer)
							{
								QuestHist[Q] = { QuestIndex: Q, Quest: curquet.Question, Opt1: curquet.CorrectAnswer, Opt2: "",Opt3:"",Opt4:"", CorrAns: 1, UserSelectedAns: 1};
							}
							else
							{
								QuestHist[Q] = { QuestIndex: Q, Quest: curquet.Question, Opt1: curquet.CorrectAnswer, Opt2: curquet.UserSelectedAnswer,Opt3:"",Opt4:"", CorrAns: 1, UserSelectedAns: 2};
							}
							sessionStorage["QuestionHistory"] = JSON.stringify(QuestHist);
							
						}
                }

            }


        },
        dataType: 'json',
        crossDomain: true,
        async: false,
        error: function (jqXHR, exception) {
            var msg = '';
            if (jqXHR.status === 0) {
                msg = 'Not connect.\n Verify Network.';
            } else if (jqXHR.status == 404) {
                msg = 'Requested page not found. [404]';
            } else if (jqXHR.status == 500) {
                msg = 'Internal Server Error [500].';
            } else if (exception === 'parsererror') {
                msg = 'Requested JSON parse failed.';
            } else if (exception === 'timeout') {
                msg = 'Time out error.';
            } else if (exception === 'abort') {
                msg = 'Ajax request aborted.';
            } else {
                msg = 'Uncaught Error.\n' + jqXHR.responseText;
            }
            
        },
        beforeSend: function () {
           
        },
        complete: function () {
            
        }
    });

}

//Save Elerning History
function SaveInToElearningHistory(sync_flags) {

    
    var HistArr = [];
    var Temp;

    if (sync_flags & SYNC_START_TIME) {
        Temp = { "CourseId": sessionStorage["CourseId"], "Element": "StartTime", "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": sessionStorage["StartTime"] };

        HistArr.push(Temp);

    }


    if (sync_flags & SYNC_LESSON_LOCATION) {
        Temp = { "CourseId": sessionStorage["CourseId"], "Element": "LessonLocation", "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": sessionStorage["LessonLocation"] };

        HistArr.push(Temp);
    }


    if (sync_flags & SYNC_SUSPEND_DATA) {
        Temp = { "CourseId": sessionStorage["CourseId"], "Element": "SuspendData", "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": sessionStorage["SuspendData"] };
        HistArr.push(Temp);
    }


    if (sync_flags & SYNC_END_TIME) {
        Temp = { "CourseId": sessionStorage["CourseId"], "Element": "EndTime", "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": sessionStorage["EndTime"] };

        HistArr.push(Temp);
    }


    if (sync_flags & SYNC_STATUS) {
        Temp = { "CourseId": sessionStorage["CourseId"], "Element": "Status", "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": sessionStorage["Status"] };

        HistArr.push(Temp);
    }


    if (sync_flags & SYNC_SCORE) {
        Temp = { "CourseId": sessionStorage["CourseId"], "Element": "Score", "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": sessionStorage["mark"] };

        HistArr.push(Temp);
    }

    if (sync_flags & SYNC_DURATION) {
        var Int_TotTime = Number(sessionStorage["SessionDuration"]) + Number(sessionStorage["TotalTime"]);
        Int_TotTime = Int_TotTime.toString();

        Temp = { "CourseId": sessionStorage["CourseId"], "Element": "TotalTime", "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": Int_TotTime };
        HistArr.push(Temp);
    }

    if (sync_flags & SYNC_ASS_HIST) {

        Temp = { "CourseId": sessionStorage["CourseId"], "Element": sessionStorage["Ass_Ques_Element"], "SiteId": Number(sessionStorage["SiteID"]), "TId": Number(sessionStorage["TId"]), "TPId": Number(sessionStorage["TPId"]), "Value": sessionStorage["Ques_History_JsonString"] };
        HistArr.push(Temp);
    }



    var HistoryJSONString = JSON.stringify(HistArr);

    if (Number(sessionStorage["IsOnline"]) == 1) {
        var Bol_Success = false;
        $.ajax({
            type: 'POST',
            url: sessionStorage["serverPath"] + "/" + sessionStorage["postElerningHistory"] + sessionStorage["SiteID"],
            success: function (data) {
                Bol_Success = true;
                //alert("savehistory"+data);
            },
            data: HistoryJSONString,
            dataType: 'json',
            contentType: "application/json; charset=utf-8",
            crossDomain: true,
            async: false,
            error: function (jqXHR, exception) {
                var msg = '';
                if (jqXHR.status === 0) {
                    msg = 'Not connect.\n Verify Network.';
                } else if (jqXHR.status == 404) {
                    msg = 'Requested page not found. [404]';
                } else if (jqXHR.status == 500) {
                    msg = 'Internal Server Error [500].';
                } else if (exception === 'parsererror') {
                    msg = 'Requested JSON parse failed.';
                } else if (exception === 'timeout') {
                    msg = 'Time out error.';
                } else if (exception === 'abort') {
                    msg = 'Ajax request aborted.';
                } else {
                    msg = 'Uncaught Error.\n' + jqXHR.responseText;
                }
                
            },
            beforeSend: function () {
               
            },
            complete: function () {
              
            }
        });
        Chk_Status = Bol_Success;
        return Bol_Success;
    }
    else {
        SendDataToApp("saveHistory", HistoryJSONString);

    }

}

function Offline_SaveExitCommand() {
    var QueryData = [{ "Exit": "Exit"}];
    SendDataToApp("Exit", JSON.stringify(QueryData));
}

//Save InTo Elearning Summary
function SaveInToElearningSummary() {

    var SummaryJSONString = { "AssgDate": sessionStorage["AssgDate"], "CompDate": sessionStorage["CompletedDate"], "CourseId": sessionStorage["CourseId"], "Id": Number(sessionStorage["TPId"]), "Score": sessionStorage["mark"], "Status": Number(sessionStorage["Status"]), "TId": Number(sessionStorage["TId"]), "UpdBy": Number(sessionStorage["UpdBy"]) };

    var SummaryJSONString = JSON.stringify(SummaryJSONString);


    if (Number(sessionStorage["IsOnline"]) == 1) {

        $.ajax({
            type: 'POST',
            url: sessionStorage["serverPath"] + "/" + sessionStorage["postElerningSummary"] + sessionStorage["SiteID"],
            success: function (data) { //alert(data);
            },
            data: SummaryJSONString,
            dataType: 'json',
            contentType: "application/json; charset=utf-8",
            crossDomain: true,
            error: function (jqXHR, exception) {
                var msg = '';
                if (jqXHR.status === 0) {
                    msg = 'Not connect.\n Verify Network.';
                } else if (jqXHR.status == 404) {
                    msg = 'Requested page not found. [404]';
                } else if (jqXHR.status == 500) {
                    msg = 'Internal Server Error [500].';
                } else if (exception === 'parsererror') {
                    msg = 'Requested JSON parse failed.';
                } else if (exception === 'timeout') {
                    msg = 'Time out error.';
                } else if (exception === 'abort') {
                    msg = 'Ajax request aborted.';
                } else {
                    msg = 'Uncaught Error.\n' + jqXHR.responseText;
                }
               
            },
            beforeSend: function () {
              
            },
            complete: function () {
               
            }
        });
    }
    else {
        SendDataToApp("saveSummary", "[" + SummaryJSONString + "]");
    }

}
